#    PyNetMony Netmonitor for S60 3rd Edition phones
#
#    Copyright (C) 2007  Carsten Knuetter, Georg Lukas
#
#    email: netmonitor.s80@o2online.de
#
#    This program is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.  This program is distributed in the hope that
#    it will be useful, but WITHOUT ANY WARRANTY; without even the implied
#    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#    GNU General Public License for more details.  You should have received a
#    copy of the GNU General Public License along with this program; if not,
#    see <http://www.gnu.org/licenses/>.


import appuifw
import e32
import os, os.path
import location
import sysinfo
import time
#import positioning
import sys
import audio
import thread
import math
#import e32db
import string
import urllib, graphics, socket

try:
	import envy
except:
	pass




try:
	import lightblue
	import blues
	bt = True
except:
	bt = False
try:
	#import camera
	import camtest
	cam = True
except:
	cam = False
try:
	import wlantools
	wlan = True
except:
	wlan = False
from key_codes import *
from graphics import *
try:
	import locationrequestor
	locreq = True
	gpsdata = [0, 'GPS disabled']
except:
	gpsdata = [0, 'Module locationrequestor not installed']
	locreq = False

# Meta data section for SIS generation
SYMBIAN_UID = 0x2000D81D
SIS_VERSION = '0.7.2'
TITLE=u'PyNetMony'
VERSION=TITLE + ' ' + SIS_VERSION

CENTER = -1

# temp variables
running=True
light=True
tab=0
tab_max=0
draw_rnc = False
s = None
finder = False
starttime = 0
key_repeat = 0


#Encoding scheme
sys.setdefaultencoding('iso-8859-1')
#sys.setdefaultencoding('utf-8')
#sys.setdefaultencoding('latin-1')

#yahoo maps
#APP_ID = "reuBqRjOdK4E3NaKfEsYopj3459fmas_xg7oa"
APP_ID = "PoKyoYjV34Hzt6xVEbtLhZXG6N6S4o5X1AhHjxgfxTnkCbg1XNbQhX4GTbpevQ--"
MAP_URL = "http://local.yahooapis.com/MapsService/V1/mapImage?"
MAP_FILE = u"E:\\Images\\pynetmonymap.png"
map_x = map_y = 0
mapimg = status = None
apo = None
apid = None

if not os.path.exists("E:\\Images"):
	os.makedirs("E:\\Images")

# XXX: use absolute path for mp3 etc.
# os.path.join(os.getcwd(), u'default_settings.xml')
datadir = "E:\\Data\\Others\\PyNetMony\\"
if not os.path.isdir(datadir):
	os.makedirs(datadir)
pic_path = "E:\\Data\\Others\\PyNetMony\\pics\\"
if not os.path.isdir(pic_path):
	os.makedirs(pic_path)
log_path = "e:\\Data\\Others\\PyNetMony\\logs\\"
if not os.path.isdir(log_path):
	os.makedirs(log_path)

# program config
configfile = "E:\\Data\\Others\\PyNetMony\\pynetmony.cfg"
# XXX configfile =  os.path.join(os.getcwd(), u'pynetmony.cfg')
defconfig = {
	'CellNotify': 0,
	'Light': 0,
	'Refresh': 10,
	'Volume': 5,
	'Voice': 0,
	'GPS': 0,
	'Neighbour Radius': 2.0,
	'WLANInter': 10,
	'CLF': 1,
	'WLAN_STORE': 1,
	'WLAN_NOTIFY': 0,
	'MAPZOOM': 3,
	'BT_SCAN': 60,
	'BT_STORE': 1,
	'BT_NOTIFY': 0,
	'BT_Autosave': 10,
	'BT_SCAN_TIMEOUT': 500}

config = defconfig.copy()

# TODO: move these to theme[xxx]
font=u"normal"
color=(255,255,255)
linecol=(255,128,128)
bg=(0,0,60)
border=bg
#border=(255,0,0)
headcol=(255,255,255)
headbg=(255,255,255)
grid=(127,127,127)

# table for RX level history
rxl_log = []
rxl_last = 0

# table for Cell history
loc_log = []
logger = None
logname = None
toggle = 2
gpsmodule = 0
gpson = 0

# XXX workaround for E90 "losing" link during data traffic
offlinetimeout = 90

# global GSM state variables
t_last = 0
rxl = None
gsmloc = gsmloc_real = None

#WLAN globals
wlan_pid = 0
wlani = 0
newwlans = 0
wlangpsupdate = 0
wscan = []
wlan_list = []
wlanquery_list = []
wlan_name = "E:\\Data\\Others\\PyNetMony\\pynetmony_wlan.txt"
wlan_name_e = "E:\\Data\\Others\\PyNetMony\\pynetmony_wlan.txt"
wlan_name_c = "C:\\Data\\Others\\PyNetMony\\pynetmony_wlan.txt"
wlogger = None
wlogname = None
show_ssid = True

#BT globals
invalid_bt = ""
bt_save_error = 0
bt_scan_time = 0
bt_err = 0
bti = 0
newbt = 0
btgpsupdate = 0
bt_busy = False
btscan = []
bt_list = []
btquery_list = []
bt_name = "E:\\Data\\Others\\PyNetMony\\pynetmony_bt.txt"
bt_name_e = "E:\\Data\\Others\\PyNetMony\\pynetmony_bt.txt"
bt_name_c = "C:\\Data\\Others\\PyNetMony\\pynetmony_bt.txt"

#clf globals
clf = []
clf_name = ""
clf_path_c = "C:\\Data\\Others\\PyNetMony\\clf\\"

if not os.path.isdir(clf_path_c):
	os.makedirs(clf_path_c)
clf_path_e = "E:\\Data\\Others\\PyNetMony\\clf\\"
if not os.path.isdir(clf_path_e):
	os.makedirs(clf_path_e)
clf_found = False
cell_searching = False
cell_description = ''
cell_lat = u'999.99999'
cell_lon = u'999.99999'
band = {0:"gsm", 1:"umts"}
oldumts = -1
oldqnet = 99999
neighbour_list = []
neighbour_updated = False


s60_ver = e32.s60_version_info
API = s60_ver[0]*10 + s60_ver[1]
del s60_ver

if API <= 12:
	MAXSIZE = (176,208)
	LINEHEIGHT = 13
	HEADHEIGHT = 32
	TABHEIGHT = 13
	TABSPACE = 4
	# Hack for S60 1stEd devices:
	# just add all the required API calls
	appuifw.app.layout = lambda lid: ((176, 208-lid*68), (0, 0))
	appuifw.EScreen = 0
	appuifw.EMainPane = 1
	sysinfo.signal_dbm = lambda: 666
	sysinfo.signal_bars = lambda: 0
	e32.reset_inactivity = lambda: None
else:
	MAXSIZE = (800,352)
	#MAXSIZE = (240,320)
	LINEHEIGHT = 20
	HEADHEIGHT = 44
	TABHEIGHT = 16
	TABSPACE = 6

# Spelling for network providers
class Voice:
	offline = u"Offline"
	band = [u"G S M", u"U M T S"]

	provider = {
		262: { 1: "Timo Beil",
		       2: "Wo da phon",
		       3: "E plus",
		       7: "Oh tuh"}
		}


		
class Logger:
	def __init__(self, log_name):
		self.logfile = log_name
	def write(self, obj):
		try:
			log_file = open(self.logfile, 'a')
			log_file.write(obj)
			log_file.close()
		except IOError, err:
			appuifw.note(u"Logger: " + unicode(err), "error")
	def writelines(self, obj):
		self.write(''.join(list))
	def logtab(self, list):
		# Convert list to unicode and add tabs
		txt = '\t'.join(map(unicode, list)) + '\n'
		self.write(txt)
	def flush(self):
		pass

class Setup( object ):
	# Config constants
	SOUND_OFF = 0
	SOUND_SOUND = 1
	SOUND_VOICE = 2

	LIGHT_OFF = 0
	LIGHT_CELL = 1
	LIGHT_ALWAYS = 2

	VOICE_CELL = 0
	VOICE_BAND = 1
	VOICE_BAND_LAC = 2
	VOICE_BAND_LAC_NET = 3
	VOICE_BAND_CLF = 4

	GPS_INTERNAL = 0
	GPS_EXTERNAL = 1
	
	CLF_DEVICE = 0
	CLF_CARD = 1
	
	WLAN_DEVICE = 0
	WLAN_CARD = 1

	WLAN_NOTIFY_OFF = 0
	WLAN_NOTIFY_ADHOC = 1
	
	BT_DEVICE = 0
	BT_CARD = 1
	
	BT_NOTIFY_OFF = 0
	BT_NOTIFY_NEW_VOICE = 1
	BT_NOTIFY_NEW_LIGHT = 2
	BT_NOTIFY_NEW_VOICE_LIGHT = 3
	
	## The constructor.
	def __init__( self ):
		global config
		## Config options
		self._iSound = [u'OFF', u'Sound', u'Voice']
		self._iLight = [u'OFF', u'Cell change on', u'Always on']
		self._iVoice = [u'Cell only',
		                u'Band & Cell',
		                u'Band & Cell & LAC',
		                u'Band & Cell & LAC & NET',
						u'Band & CLF']
		self._iGPS = [u'Internal', u'External']
		self._iCLF = [u'Device', u'Memory Card']
		self._iWLAN_Store = [u'Device', u'Memory Card']
		self._iWLAN_Notify = [u'OFF', u'AD-HOC']
		self._iBT_Store = [u'Device', u'Memory Card']
		self._iBT_Notify = [u'OFF', u'Voice', u'Light', u'Voice & Light']
		## Setup Menu
		self._iMenu = [(u'Defaults', self.defaultConfig),
		               (u'Reload Config File', self.loadConfig)]
		## Form fields
		self.configToForm()
		#flags = appuifw.FFormEditModeOnly
		flags = appuifw.FFormEditModeOnly + appuifw.FFormDoubleSpaced
		self._iForm = appuifw.Form(self._iFields, flags)
		self._iForm.save_hook = self.saveForm
		#self._iForm.flags = appuifw.FFormEditModeOnly
		self._iForm.menu = self._iMenu

	def configToForm(self):
		global config
		_iFields = [( u'Cellselection Notifier', 'combo', ( self._iSound, config['CellNotify'] ) ),
		            ( u'Light', 'combo', ( self._iLight, config['Light'] ) ),
		            ( u'WLAN Scan [s] (off=0 / on>9)','number', config['Refresh'] ),
		            ( u'Volume','number', config['Volume'] ),
		            ( u'Voice Text','combo', (self._iVoice, config['Voice']) ),
		            ( u'GPS', 'combo', ( self._iGPS, config['GPS'] ) ),
					( u'Neighbour Radius [km]', 'float', config['Neighbour Radius']),
					( u'WLAN Autosave Interval [min]','number', config['WLANInter']),
					( u'CLF stored on','combo', (self._iCLF, config['CLF'])),
					( u'WLAN Database stored on','combo', (self._iWLAN_Store, config['WLAN_STORE'])),
					( u'WLAN Notifier','combo', (self._iWLAN_Notify, config['WLAN_NOTIFY'])),
					( u'Map Zoom Level (1-12)','number', config['MAPZOOM']),
					( u'Time between BT Scans [s] 0=off','number', config['BT_SCAN']),
					( u'BT Database stored on','combo', (self._iBT_Store, config['BT_STORE'])),
					( u'BT Notifier','combo', (self._iBT_Notify, config['BT_NOTIFY'])),
					( u'BT Autosave Interval [min]','number', config['BT_Autosave']),
					( u'BT Scan Timeout [s]','number', config['BT_SCAN_TIMEOUT'])]
		## XXX: live update doesn't work yet. Need fixing
		if hasattr(self, '_iFields'):
			for i in range(len(_iFields)):
				self._iFields[i] = _iFields[i]
		else:
			self._iFields = _iFields

	def formToConfig(self):
		global config
		## XXX: must find elegant way for conversion Form <-> config
		config = {
			'CellNotify': self._iFields[0][2][1],
			'Light': self._iFields[1][2][1],
			'Refresh': self._iFields[2][2],
			'Volume': self._iFields[3][2],
			'Voice': self._iFields[4][2][1],
			'GPS': self._iFields[5][2][1],
			'Neighbour Radius': self._iFields[6][2],
			'WLANInter': self._iFields[7][2],
			'CLF': self._iFields[8][2][1],
			'WLAN_STORE': self._iFields[9][2][1],
			'WLAN_NOTIFY': self._iFields[10][2][1],
			'MAPZOOM': self._iFields[11][2],
			'BT_SCAN': self._iFields[12][2],
			'BT_STORE': self._iFields[13][2][1],
			'BT_NOTIFY': self._iFields[14][2][1],
			'BT_Autosave': self._iFields[15][2],
			'BT_SCAN_TIMEOUT': self._iFields[16][2]
			}
		cfgfile = open(configfile, 'wt')
		cfgfile.write(repr(config))
		cfgfile.close()

	def defaultConfig(self):
		global config, defconfig
		config = defconfig.copy()
		self.configToForm()
		appuifw.note(u"Please reopen the Setup dialog.")

	def loadConfig(self, silent=False):
		global config
		config = defconfig.copy()
		try:
			cfgfile = open(configfile, 'rt')
			content = cfgfile.read()
			cfgfile.close()

			config.update(eval(content))
			if not silent:
				appuifw.note(u"Please reopen the Setup dialog.")
		except IOError, error:
			if not silent:
				appuifw.note(unicode(error),'error')
		self.configToForm()

	## Displays the form.
	def execute( self ):
		self._iForm.execute( )

	## save_hook send True if the form has been saved.
	def saveForm( self, aConfig ):
		global config
		self._iFields = aConfig
		self.formToConfig()

class CellCam:
	SIZE = (640,480)

	def __init__(self):
		global finder
		self.timeout = 100
		self.lock = e32.Ao_lock()
		finder = True
		self.oldexit = appuifw.app.exit_key_handler
		appuifw.app.exit_key_handler = self.abort
		appuifw.app.body.bind(EKeySelect, self.take_picture)
		camera.start_finder(self.finder_cb)
		self.lock.wait()

	def abort(self):
		camera.stop_finder()
		self.finish()

	def finish(self):
		global finder
		appuifw.app.body.bind(EKeySelect, None)
		appuifw.app.exit_key_handler = self.oldexit
		self.lock.signal()
		finder = False

	def take_picture(self):
		global finder, gsmloc
		fname = rxl_line(gsmloc, fname=True)
		camera.stop_finder()
		img = camera.take_photo(size=CellCam.SIZE)
		appuifw.note(u"Good Shot!",'info')
		w, h = appuifw.app.body.size
		appuifw.app.body.blit(img,target=(0, 0, w, 0.75 * w), scale = 1)
		appuifw.app.body.text((10,20), u"Writing Image:", fill=color)
		appuifw.app.body.text((10,40), fname, fill=color)
		img.save(pic_path + fname)
		self.finish()
		
	def finder_cb(self, im):
		global gsmloc
		info = rxl_line(gsmloc)
		im.text((10,20), info, fill=color)
		#im.text((10,40), u"Feature test: " + unicode(self.timeout), fill=color)
		appuifw.app.body.blit(im)
		

		
img=Image.new(MAXSIZE)
img_dbl=Image.new(MAXSIZE)

#some text measurements
#(box,TLENGTH_199DBM,numb) = img.measure_text(u'-199dDm')
#(box,TLENGTH_RXL,numb) = img.measure_text(u'-199')
#(box,TLENGTH_WPAPSK,numb) = img.measure_text(u'WpaPsk')
#(box,TLENGTH_C,numb) = img.measure_text(u'C')
(box,TLENGTH_TIME,numb) = img.measure_text(u'23:59:59')
#(box,numb,numb) = img.measure_text(u'ABCDEFGHIJKLMNOPQRSTUVWXY09,()')
#TABHEIGHT = box[3] - box[1] + 2
(box,numb,numb) = img.measure_text(u'ABCDEFGHIJKLMNOPQRSTUVWXYabcdefghijklmnopqrstuvwxyz09,;!#()')
TABHEIGHT = LINEHEIGHT = box[3] - box[1] + 0
LINEY = -box[1] + 1

# Headline size: frame; total height; y position for text
HDLFRAME = 2
(HDLBOX,numb,numb) = img.measure_text(u'C: 99999 W: G:')
HDLH = HDLBOX[3] - HDLBOX[1] + 2*HDLFRAME
HDLY = -HDLBOX[1] + HDLFRAME
HEADHEIGHT = 2*HDLH + 2*HDLFRAME
del HDLBOX, box, numb

def mainmenu_setup():
	global logger, gpson, cam
	logmenu = [(u"Start 2G/3G Logging", toggle_log),
	           (u"Stop 2G/3G Logging", toggle_log)]
	gpsmenu = [(u"Start GPS", toggle_gps), (u"Stop GPS", toggle_gps)]
	cammenu = [[], [(u"Site Photo...", cellphoto)]]
	wlogmenu = [(u"Start WLAN Logging", toggle_wlog), (u"Stop WLAN Logging", toggle_wlog)]
	appuifw.app.menu = [logmenu[logger != None],
						wlogmenu[wlogger != None],
	                    gpsmenu[gpson],
			    (u"Orientation", rotate)] + \
				[(u"Database", ((u"Calculate Neighbour", neighbour_start), (u"Save CLF", save_clf), (u"Save WLAN DB", save_wlan), (u"Save BT DB", save_bt)))] + \
				[(u"Map", ((u"Show Cell Position", cell_map), (u"Show GPS Position", own_map), (u"Select Default APN", select_apn)))] + \
			    cammenu[cam] + \
	                   [(u"Settings...", setup)]		   

def menus_setup():
	global tab, tab_max
	mainmenu_setup()
	tabs = [u"NetMon", u"Graph", u"History", u"GPS", u"WLAN", u"CellInfo", u"Radar", u"Map", u"BT", u"Neighbour", u"About"]
	tab_max = len(tabs)
	appuifw.app.set_tabs(tabs, set_tab)
	appuifw.app.activate_tab(tab)

def uptime(start):
	diff = time.time()-start
	dmin = math.floor(diff/60)
	dday = int(math.floor(diff/86400))
	dhour = int(math.floor((dmin - dday*24*60)/60))
	dmin = int(math.floor(dmin - dhour*60 - dday*24*60))
	dmin = unicode('%02i'%dmin)
	dhour = unicode('%02i'%dhour)
	dday = unicode(dday)
	return (dday,dhour,dmin)
	
def rotate():
	if appuifw.app.orientation == 'landscape':
		appuifw.app.orientation = 'portrait'
	else:
		appuifw.app.orientation = 'landscape'
	if tab==6:	
		appuifw.app.body=lb

def setup():
	global wlanlist, wscan
	# Bug in Form(): manually hide Tabs
	appuifw.app.set_tabs([], None)
	SetupForm.execute( )
	if config['Refresh']<2:
		wlanlist = ""
		wscan = []
	menus_setup()

def set_tab(newtab):
	global tab, gui
	tab = newtab
	gui.signal()
	
def naive_xml_parser(key, xml):
	key = key.lower()
	for tag in xml.split("<"):
		tokens = tag.split()
		if tokens and tokens[0].lower().startswith(key):
			return tag.split(">")[1].strip()
	return None

def select_apn():
	global apo, apid
	apid = socket.select_access_point()
	apo = socket.access_point(apid)
	socket.set_default_access_point(apo)
	
def cell_map():
	appuifw.app.activate_tab(7)
	set_tab(7)
	new_map(cell_lat, cell_lon, zoom=config['MAPZOOM'], size=gl_size)
	#thread.start_new_thread(new_map,(cell_lat, cell_lon))
	
def own_map():
	if (len(gpsdata) == 15) and (gpsdata[14] > 2):
		appuifw.app.activate_tab(7)
		set_tab(7)
		new_map(gpsdata[1], gpsdata[2], zoom=config['MAPZOOM'], size=gl_size)

def new_map(latitude, longitude, zoom=3, size=(240,320), radius=""):
	global apo
	#addr = appuifw.query(u"Address:", "text")
	#if not addr:
	#	return
	if apo == None:
		select_apn()
	(w, h) = size
	params = {"latitude": latitude,
			  "longitude": longitude,
			  "appid": APP_ID,
			  "image_type": "png",
			  "image_height": h,
			  "image_width": w,
			  "zoom": zoom,
			  "radius": radius}
				
	show_text(u"Loading map...")
	try:
		url = MAP_URL + urllib.urlencode(params)
		res = urllib.urlopen(url).read()
		
	except:
		show_text(u"Network error")
		return

	img_url = naive_xml_parser("result", res)
	if img_url:
		show_text(u"Loading map......")
		load_image(img_url)
		handle_redraw(canvas.size)
		apo.stop()
	else:
		msg = naive_xml_parser("message", res)
		show_text(u"%s" % msg)
		apo.stop()
		
def load_image(url):
	global mapimg, map_x, map_y, status
	res = urllib.urlopen(url).read()
	f = file(MAP_FILE, "w")
	f.write(res)
	f.close()
	mapimg = graphics.Image.open(MAP_FILE)
	map_x = mapimg.size[0] / 2 - canvas.size[0] / 2
	map_y = mapimg.size[1] / 2 - canvas.size[1] / 2
	status = None
	
def show_text(txt):
	global status
	status = txt
	handle_redraw(canvas.size)
	
def toggle_gps():
	global gpson, locreq, gpsdata
	if not locreq:
		appuifw.note(u"Module Locationrequestor not installed!",'error')
		return
	if not gpson:
		gpsdata = [0, 'Starting GPS...']
		gpson = 1
		mainmenu_setup()
		thread.start_new_thread(gps_worker,())
	else:
		gpson = 0
		mainmenu_setup()
		
	
def query_clf(mcc, mnc, cid, lac, rnc, umts):
	global cell_description, cell_lon, cell_lat, oldumts, oldqnet, clf_name, clf_found, clf, cell_searching
	i = 0
	while cell_searching:
		e32.ao_sleep(0.5)
		i += 1
		if i > 120:
			break
	cell_found = False
	cell_searching = True
	qnet = '%03i%02i' % (mcc, mnc)
	qcid = '%05i' % (cid)
	qlac = '%05i' % (lac)
	if (umts != oldumts) or (qnet != oldqnet):
		oldumts = umts
		oldqnet = qnet
		if config['CLF'] == Setup.CLF_DEVICE:
			clf_name = clf_path_c+qnet+"_"+band[umts]+".clf"
		else:
			clf_name = clf_path_e+qnet+"_"+band[umts]+".clf"
		cell_description = unicode('Loading '+clf_name)
		try:
			clf = []
			file = open(clf_name)
			clf = file.readlines()
			file.close()
			clf_found = True
		except IOError:
			cell_description = unicode(clf_name)+u' not found!'
			clf_found = False
			cell_lat = u'999.99999'
			cell_lon = u'999.99999'
	
	if clf_found:
		cell_description = u'searching...'
		if qnet == '26207':
			qlac = qlac[:3]
			for query in clf:
				if (query[:5]==qnet) and (query[6:11]==qcid) and (query[12:15]==qlac):
					splitter = query.split(';')
					cell_lat = unicode(splitter[4])
					cell_lon = unicode(splitter[5])
					cell_description = unicode(splitter[7])
					cell_found = True
					if config['CellNotify']==Setup.SOUND_VOICE and config['Voice']==Setup.VOICE_BAND_CLF:
						thread.start_new_thread(reader,(cell_description,))
					break
		elif qnet == '26203':
			qlac = qlac[4:5]
			for query in clf:
				if (query[:5]==qnet) and (query[6:11]==qcid) and (query[16:17]==qlac):
					splitter = query.split(';')
					cell_lat = unicode(splitter[4])
					cell_lon = unicode(splitter[5])
					cell_description = unicode(splitter[7])
					cell_found = True
					if config['CellNotify']==Setup.SOUND_VOICE and config['Voice']==Setup.VOICE_BAND_CLF:
						thread.start_new_thread(reader,(cell_description,))
					break
		else:
			for query in clf:
				if (query[:5]==qnet) and (query[6:11]==qcid):
					splitter = query.split(';')
					cell_lat = unicode(splitter[4])
					cell_lon = unicode(splitter[5])
					cell_description = unicode(splitter[7])
					cell_found = True
					if config['CellNotify']==Setup.SOUND_VOICE and config['Voice']==Setup.VOICE_BAND_CLF:
						thread.start_new_thread(reader,(cell_description,))
					break			
		if not cell_found:
			cell_description = u'unknown cell'
			cell_lat = u'999.99999'
			cell_lon = u'999.99999'
			if config['CellNotify']==Setup.SOUND_VOICE and config['Voice']==Setup.VOICE_BAND_CLF:
				thread.start_new_thread(reader,(cell_description,))
	cell_searching = False

		
def query_wlan(wlanset):
	global wlan_list, newwlans, wlangpsupdate
	wlan_found = False
	i = 0
	if len(gpsdata) == 15:
		try:
			wlan_lat = '%0.6f'%float(gpsdata[1])
			wlan_lon = '%0.6f'%float(gpsdata[2])
		except:
			wlan_lat = gpsdata[1]
			wlan_lon = gpsdata[2]
	for query in wlan_list:
		if wlanset['BSSID']== query[:17]:
			wlist = wlan_list[i].split(';')
			rest = u';'+unicode(wlanset['SSID'])+u';'+unicode(wlanset['SecurityMode'])+u';'+unicode(wlanset['BeaconInterval'])+u';'+unicode(wlanset['ConnectionMode'][:5])+u';'+unicode(wlanset['Channel'])+u';'+unicode(-abs(wlanset['RxLevel']))+u';'+unicode(time.strftime("%Y/%m/%d"))+u';'+unicode(time.strftime("%H:%M:%S"))+u'\n'
			if (len(gpsdata) == 15) and (gpsdata[14] > 2) and ((int(wlist[8]) <= int(wlanset['RxLevel'])) or (wlist[1] == u'NaN')):
				wlan_list[i] = unicode(wlanset['BSSID'])+u';'+unicode(wlan_lat)+u';'+unicode(wlan_lon)+rest
				wlangpsupdate += 1
			wlan_found = True
			return False
			break
		i += 1
			
	if not wlan_found:
		rest = u';'+unicode(wlanset['SSID'])+u';'+unicode(wlanset['SecurityMode'])+u';'+unicode(wlanset['BeaconInterval'])+u';'+unicode(wlanset['ConnectionMode'][:5])+u';'+unicode(wlanset['Channel'])+u';'+unicode(-abs(wlanset['RxLevel']))+u';'+unicode(time.strftime("%Y/%m/%d"))+u';'+unicode(time.strftime("%H:%M:%S"))+u'\n'
		if len(gpsdata) == 15:
			wlan_list.append(unicode(wlanset['BSSID'])+u';'+unicode(wlan_lat)+u';'+unicode(wlan_lon)+rest)
		else:
			wlan_list.append(unicode(wlanset['BSSID'])+u';'+u'NaN'+u';'+u'NaN'+rest)
		newwlans += 1
		if (config['WLAN_NOTIFY'] == Setup.WLAN_NOTIFY_ADHOC) and (wlanset['ConnectionMode'] == 'Adhoc'):
			thread.start_new_thread(reader,(u'ad-hoc weh lahn network',))
		return True
		
def query_bt(btset):
	global bt_list, newbt, btgpsupdate
	bt_found = False
	i = 0
	if len(gpsdata) == 15:
		try:
			bt_lat = '%0.6f'%float(gpsdata[1])
			bt_lon = '%0.6f'%float(gpsdata[2])
		except:
			bt_lat = gpsdata[1]
			bt_lon = gpsdata[2]
	for query in bt_list:
		if btset[0]== query[:17]:
			blist = bt_list[i].split(';')
			if len(btset[1]) > 0:
				rest = u';'+unicode(btset[1])+u';'+unicode(btset[2])+u';'+unicode(time.strftime("%Y/%m/%d"))+u';'+unicode(time.strftime("%H:%M:%S"))+u';'+unicode(btset[3])+u'\n'
			else:
				rest = u';'+unicode(blist[3])+u';'+unicode(btset[2])+u';'+unicode(time.strftime("%Y/%m/%d"))+u';'+unicode(time.strftime("%H:%M:%S"))+u';'+unicode(btset[3])+u'\n'
			if ((len(gpsdata) == 15) and (gpsdata[14] > 2) and (blist[1] == u'NaN')) or ((unicode(blist[3]) <> unicode(btset[1])) and (len(btset[1]) > 0)):
				if (len(gpsdata) == 15) and (gpsdata[14] > 2):
					bt_list[i] = unicode(btset[0])+u';'+unicode(bt_lat)+u';'+unicode(bt_lon)+rest
				else:
					bt_list[i] = unicode(btset[0])+u';'+blist[1]+u';'+blist[2]+rest
				btgpsupdate += 1
			bt_found = True
			return False
			break
		i += 1
			
	if not bt_found:
		rest = u';'+unicode(btset[1])+u';'+unicode(btset[2])+u';'+unicode(time.strftime("%Y/%m/%d"))+u';'+unicode(time.strftime("%H:%M:%S"))+u';'+unicode(btset[3])+u'\n'
		if len(gpsdata) == 15:
			bt_list.append(unicode(btset[0])+u';'+unicode(bt_lat)+u';'+unicode(bt_lon)+rest)
		else:
			bt_list.append(unicode(btset[0])+u';'+u'NaN'+u';'+u'NaN'+rest)
		newbt += 1
		if (config['BT_NOTIFY'] == Setup.BT_NOTIFY_NEW_VOICE) or (config['BT_NOTIFY'] == Setup.BT_NOTIFY_NEW_VOICE_LIGHT):
			thread.start_new_thread(reader,(u'Neues Blu tus in Reichweite',))
		if (config['BT_NOTIFY'] == Setup.BT_NOTIFY_NEW_VOICE_LIGHT) or (config['BT_NOTIFY'] == Setup.BT_NOTIFY_NEW_LIGHT):
			e32.reset_inactivity()
		return True
		

def save_clf():
	global clf, clf_name
	file = open(clf_name,'w')
	file.writelines(clf)
	file.close()

def save_wlan():
	global wlan_name
	file = open(wlan_name,'w')
	file.writelines(wlan_list)
	file.close()
	
def save_bt():
	global bt_name,  bt_list, bt_save_error, invalid_bt
	save_error = False
	try:
		file = open(bt_name,'w')
		file.writelines(bt_list)
		file.close()
	except:
		save_error = True
		file.close()
	
	while save_error:
		bt_save_error += 1
		try:
			file = open(bt_name,'w')
			for i in range(len(bt_list)):
				file.write(bt_list[i])
			file.close()
			save_error = False
		except:
			file.close()
			invalid_bt = bt_list[i]
			del bt_list[i]
			save_error = True
		
	
	
def load_wlan():
	global wlan_list, wlan_name
	if config['WLAN_STORE'] == Setup.WLAN_DEVICE:
		wlan_name = wlan_name_c
	else:
		wlan_name = wlan_name_e
	try:
		file = open(wlan_name)
		wlan_list = file.readlines()
		file.close()
	except IOError:
		header = u'BSSID;LAT;LON;SSID;Crypt;Beacon Interval;Connection Mode;Channel;RXL;Date;Time\n'
		wlan_list.append(header)
		
def load_bt():
	global bt_list, bt_name
	if config['BT_STORE'] == Setup.BT_DEVICE:
		bt_name = bt_name_c
	else:
		bt_name = bt_name_e
	try:
		file = open(bt_name)
		bt_list = file.readlines()
		file.close()
	except IOError:
		header = u'MAC;LAT;LON;Name;Class ID;Date;Time;Class\n'
		bt_list.append(header)
			
def cellphoto():
	appuifw.app.set_tabs([], None)
	c = CellCam()
	menus_setup()

def toggle_log():
	global logger, logname
	if not logger:
		logname = log_path+"NetMonLog_"+time.strftime("%Y%m%d_%H%M%S")+".txt"
		logger = Logger(logname)
		#sys.stderr = sys.stdout = my_log
		logger.logtab(("Date (Y/M/D)", "Time (H:M:S)", "CID", "LCID", "LAC", "MCC", "MNC", "RNC", "RXL", "LON", "LAT"))
	else:
		logger = None
	mainmenu_setup()
	
def toggle_wlog():
	global wlogger, wlogname
	if not wlogger:
		wlogname = log_path+"WLAN_Log_"+time.strftime("%Y%m%d_%H%M%S")+".txt"
		wlogger = Logger(wlogname)
		#sys.stderr = sys.stdout = my_log
		wlogger.logtab(("Date (Y/M/D)", "Time (H:M:S)", "BSSID", "SSID", "RXL", "LAT", "LON"))
	else:
		wlogger = None
	mainmenu_setup()

def writelog(list):
	#my_log = Logger(logname)
	#sys.stderr = sys.stdout = my_log
	logger.logtab(list)
	
def writewlog(list):
	#my_log = Logger(logname)
	#sys.stderr = sys.stdout = my_log
	wlogger.logtab(list)


def sound_play():
	global s
	if not s:
		return
	try:
		s.set_volume(config['Volume'])
		s.play()
	except Exception, error:
		pass
		#appuifw.note(u"Sound Error:" + unicode(error),'error')
		


def distance(lat1, lon1, lat2, lon2):
	if (lat1==lat2) and (lon1==lon2):
		return (0, 0)
	else:
		#H2 = math.radians(lat1)
		#H3 = math.radians(lon1)
		#H4 = math.radians(lat2)
		#H5 = math.radians(lon2)
		H2 = lat1*math.pi/180
		H3 = lon1*math.pi/180
		H4 = lat2*math.pi/180
		H5 = lon2*math.pi/180
		
		I5 = math.sin(H2)*math.sin(H4)+math.cos(H2)*math.cos(H4)*math.cos(H3-H5)
		if (lon1-lon2) < 0:
			J5 = 0
		else:
			J5 = 360
		direction = math.fabs(math.acos(math.sin(H4)/math.sin(math.acos(I5))/math.cos(H2)-math.tan(H2)/math.tan(math.acos(I5)))*180/math.pi-J5)
		dist = 6371.229*math.acos(I5)
		return (dist, direction)
		
def diffangle(head, dir):
	try:
		head = int(round(head))
		dir = int(round(dir))
		x = dir - head
		if x < 0:
			x = 360 + x
		return x
	except:
		x = -999
		return x

def neighbour_start():
	global neighbour_updated, lb
	lb = appuifw.Listbox([u'Calculating . . .'], handle_selection)
	neighbour_updated = False
	thread.start_new_thread(neighbour,())
	
def neighbour_update():
	lb = appuifw.Listbox(neighbour_list, handle_selection)
		
def neighbour():
	global neighbour_list, cell_lat, cell_lon, lb, neighbour_updated, gpsdata
	neighbour_list = []
	ncell_lat = u'999.99999'
	ncell_lon = u'999.99999'
	nstart_lat = u'999.99999'
	nstart_lon = u'999.99999'
	if len(gpsdata) == 15:
		if float(gpsdata[14]) > 2:
			nstart_lat = gpsdata[1]
			nstart_lon = gpsdata[2]
		elif cell_lat != u'999.99999':
			nstart_lat = cell_lat
			nstart_lon = cell_lon
	elif cell_lat != u'999.99999':
			nstart_lat = cell_lat
			nstart_lon = cell_lon
	
	if nstart_lat != u'999.99999':
		for query in clf:
			if query[:1]!='/':
				ncid = query[6:11]
				query = query[24:]
				cut = query.find(';')
				ncell_lat = unicode(query[:cut])
				query = query[cut+1:]
				cut = query.find(';')
				ncell_lon = unicode(query[:cut])
				query = query[cut+1:]
				cut = query.find(';')
				query = query[cut+1:]
				cut = query.find(';')
				cell_description = unicode(query[:cut])
				if (len(ncell_lat) > 1) and (len(ncell_lon) > 1):
					(dx, az) = distance(float(nstart_lat), float(nstart_lon), float(ncell_lat), float(ncell_lon))
					if dx < config['Neighbour Radius']:
						neighbour_list.append(unicode('%0.3f km '%dx)+unicode('%0.1f '%az)+unicode(ncid)+u' '+cell_description)
		neighbour_list.sort()
	else:
		neighbour_list.append(u'Position unknown!')
	if len(neighbour_list) == 0:
		neighbour_list.append(u'No Neighbour found!')
	neighbour_updated = True
		
def handle_selection():
	index = lb.current()
	if len(neighbour_list) > 0:
		notetext = neighbour_list[index]
		appuifw.note(unicode(notetext), 'info')		
	
		
def decode_cid(mcc, mnc, cid):
	global draw_rnc
	#if (mnc == 7) and (mcc == 262) and (cid > 65535):
	if cid > 65535:
		cidhex="%X" % cid
		rnc=int(cidhex[:-4],16)
		cid=int(cidhex[-4:],16)
		draw_rnc = True
		return (cid, rnc)
	else:
		return (cid, 'n/a')


def log_rxl(t, rxl):
	global rxl_log, rxl_last
	if not rxl:
		rxl = 0
	if rxl_last == 0:
		rxl_last = t - 1
	while t > rxl_last:
		# rescue last 1000 entries, negate for easier drawing
		rxl_log = rxl_log[-999:] + [-rxl]
		rxl_last += 1

def dbm(rxl):
	if not rxl:
		return u"Offline"
	else:
		return unicode(rxl) + u" dBm"

def log_loc(t, gsmloc):
	global loc_log
	if len(loc_log) > 0 and gsmloc == loc_log[-1:][0][1]:
		return
	loc_log += [[t, gsmloc]]

def draw_setup(ystart=HEADHEIGHT, ydelta=LINEHEIGHT):
	global imgy, deltay
	imgy = ystart
	deltay = ydelta

def draw_space(yspace=5):
	global imgy
	imgy += yspace

def draw_text(x, utext, space=0, width=320, xd = TABSPACE):
	global img, imgy, deltay
	if x == -1:
		(box,tlength,numb) = img.measure_text(utext,maxwidth=width-xd)
		x = (width-tlength)/2
		while numb < len(utext):
			numb_temp = utext[:numb].rfind(' ')
			if numb_temp > 0:
				numb = numb_temp
			(box,tlength,numb2) = img.measure_text(utext[:numb],maxwidth=width-xd)
			x = (width-tlength)/2
			img.text((x, imgy), utext[:numb], fill=color)
			imgy += deltay + space
			utext = utext[numb:]
			(box,tlength,numb) = img.measure_text(utext,maxwidth=width-xd)
			x = (width-tlength)/2
			
	img.text((x, imgy), utext, fill=color)
	imgy += deltay + space

def measure_table(lformat, rformat=[], tabspace=TABSPACE):
	global img
	x = tabspace/2
	xleft = []
	xright = []
	# add the width of all fmtlist entries together
	for fmt in lformat:
		# add current cursor to the xpos list
		xleft += [x]
		rect,width,cursor = img.measure_text(unicode(fmt))
		x += width + tabspace
	leftwidth = x
	x = tabspace/2
	#x = 0
	rf = list(rformat)
	rf.reverse()
	for fmt in rf:
		rect,width,cursor = img.measure_text(unicode(fmt))
		x -= (width + tabspace)
		xright += [x]
	xright.reverse()
	rightwidth = -x
		
	#print xleft, xright
	return xleft + xright, (leftwidth + tabspace + rightwidth)


def draw_table(xlist, textlist, space=0, width=320, highlight=False, italic=False):
	global img, imgy, deltay
	if highlight:
		img.rectangle((0,imgy-(HDLH-2*HDLFRAME)-1,width,imgy+1),headcol,fill=headbg)
	if italic:
		myfont = (None,None,FONT_ITALIC)
	else:
		myfont = (None,None,None)
	for i in range(len(xlist)):
		x = xlist[i]
		if x < 0:
			x += width
		if highlight:
			#img.rectangle((0,imgy-HDLH,width,imgy),headcol,fill=headbg)
			img.text((x, imgy), unicode(textlist[i]), fill=bg, font=myfont)
		else:
			img.text((x, imgy), unicode(textlist[i]), fill=color, font=myfont)
	imgy += deltay + space
	

def draw_about(imei):
	global img
	size,offset = appuifw.app.layout(appuifw.EMainPane)
	(w, h) = size
	img.rectangle((0,0)+size,outline=border,fill=bg)
	draw_setup(LINEHEIGHT, LINEHEIGHT)
	draw_text(CENTER, VERSION, space=5, width=w)
	draw_text(CENTER, chr(169)+u' 2008 by', space=2, width=w)
	draw_text(CENTER, u'Carsten Kntter, Georg Lukas', space=5, width=w)
	draw_text(CENTER, u'netmonitor.s80@o2online.de', space=10, width=w)
	GPL = 'This program comes with ABSOLUTELY NO WARRANTY. This is free software, and you are welcome to redistribute it under certain conditions.'
	#for line in GPL:
	draw_text(CENTER, unicode(GPL), space = 2, width=w)
	draw_space(5)
	draw_text(CENTER, unicode('IMEI: '+imei), space = 2, width=w)
	dup = uptime(starttime)
	draw_text(CENTER, unicode('Uptime: '+dup[0]+'d '+dup[1]+'h '+dup[2]+'m '), space = 2, width=w)

def draw_netmon(lac, mcc, mnc, rnc, rxl, ver, imei, longcid, cidhex, lachex, longcidhex, size, cid):
	global img
	(w, h) = size
	try:
		bars = sysinfo.signal_bars()
	except SystemError:
		bars = u"n/a" 
	batty = sysinfo.battery()
	if API <= 26:
		# Fix for pre-2ndFP1
		batty = int(batty * 14.3)
	ram = sysinfo.free_ram()/1024
	totram = sysinfo.total_ram()/1024
	x = appuifw.app.layout(appuifw.EScreen)

	draw_setup(HEADHEIGHT, LINEHEIGHT)
	#xpos = (3, 45)
	xpos, tabw = measure_table(('LCID:', 'XXX'))

	if longcid == u'n/a':
		band = 'GSM';
		draw_table(xpos, ('CID:', unicode(cid)+'  ('+unicode(cidhex)+u')'))
	else:
		draw_table(xpos, ('LCID:', unicode(longcid)+' ('+unicode(longcidhex)+u')'))
		draw_table(xpos, ('RNC:', rnc))
		band = 'UMTS';
	draw_table(xpos, ('LAC:', unicode(lac)+u'  ('+unicode(lachex)+u')'))
	if mcc is None or mcc == u'n/a' or mcc == u'busy':
		net = u'n/a'
	else:
		net = u'%03i-%02i (%s)' % (mcc, mnc, band)
	draw_table(xpos, ('NET:', net))
	draw_table(xpos, ('RXL:', '%s (%s)' % (dbm(rxl), bars)))
	draw_table(xpos, ('BAT:', '%i %%' % batty))
	draw_table(xpos, ('RAM:', '%i / %i KB' % (ram, totram)))
	if (cell_lat != u'999.99999') and (gpson == 1) and (len(gpsdata) == 15):
			(dx, az) = distance(float(gpsdata[1]), float(gpsdata[2]), float(cell_lat), float(cell_lon))
			draw_table(xpos, ('CDIR:', '%0.3f km    %0.1f' % (dx, az)+u''))
	draw_space(3)
	draw_text(CENTER, cell_description, space=2, width=w)
	#draw_table(xpos, ('IMEI:', imei))
	#draw_table(xpos, ('VER:', ver))
	#draw_table(xpos, ('RES:', x))
	#draw_text(3,  u'APP: '+appuifw.app.full_name())

def draw_rxl_line(size, pos, text):
	if e32.s60_version_info == (1, 2):
		return
	sz = (size[1]-2, 20)
	i = Image.new(sz, '1')
	i.rectangle((0,0)+sz, fill=0x000000)
	i.text((2,11), text, 0xffffff)
	irot = i.transpose(ROTATE_90)
	img.blit(irot, target=pos, mask=irot)

def headline(size, cid):
	(w, h) = size
	# CLK and CID always on top
	img.rectangle((0,0,w,HDLH),headcol,fill=headbg)
	img.text((w-TLENGTH_TIME-HDLFRAME,HDLY), unicode(time.strftime("%H:%M:%S")),fill=bg)
	if (w > 240):
		img.text((w/2-100,HDLY), u'T'+unicode(bt_scan_time),fill=bg)
		img.text((w/2+50,HDLY),u'e:'+unicode(bt_err),fill=bg)
		#img.text((w/2-200,HDLY),unicode(wlan_pid),fill=bg)
		
	if logger:
		#img.point((w/2-40,HDLH/2),(255,0,0),width=HDLH-2*HDLFRAME)
		img.text((HDLFRAME,HDLY), unicode(cid),fill=(255,0,0))
	else:
		img.text((HDLFRAME,HDLY), unicode(cid),fill=bg)
	if wlan and (config['Refresh']>1):
		if wlogger:
			img.text((w/2-28,HDLY), u'W'+unicode(len(wscan)),fill=(255,0,0))
		else:
			img.text((w/2-28,HDLY), u'W'+unicode(len(wscan)),fill=bg)
	if config['BT_SCAN']>0:
		if bt_busy:
			img.text((w/2-62,HDLY), u'B'+unicode(len(btscan)),fill=(255,0,0))
		else:
			img.text((w/2-62,HDLY), u'B'+unicode(len(btscan)),fill=bg)
	if (gpson == 1):
		if (len(gpsdata) == 15):
			gpsstat = unicode(gpsdata[14])
		else:
			gpsstat = u"*"
		img.text((w/2+12,HDLY), u'G'+gpsstat,fill=bg)

def rxl_line(log, fname=False):
	(mcc, mnc, lac, cid) = log
	longcid = cid
	(cid, rnc) = decode_cid(mcc, mnc, cid)
	if mcc is None:
		return u"Offline"
	else:
		if fname:
			return u'%03i-%02i_%05i-%i.jpg' % (mcc, mnc, lac, longcid)
		else:
			return u'%03i-%02i C:%i L:%i' % (mcc, mnc, cid, lac)

def draw_rxlgraph(size):
	global rxl_log, loc_log, t_last
	if len(rxl_log) == 0:
		return
	t = t_last
	(width, height) = size
	sublog = rxl_log[-width:]
	xcoord = range(width-len(sublog)+1, width+1)
	line = zip(xcoord, sublog)
	img.line(line, outline=linecol)
	x = width
	l = len(loc_log)-1
	while x > -20 and l >= 0:
		offset = t - loc_log[l][0]
		x = width - offset
		img.line((x, 0, x ,height),outline=linecol)
		draw_rxl_line(size, (x+1, 1), rxl_line(loc_log[l][1]))
		l-=1
	draw_setup()
	draw_text(3, dbm(-rxl_log[-1:][0]))

def draw_history(size):
	global loc_log
	(width, height) = size

	# count is: vertical space starting after headline and table head,
	# divided by height of table lines
	vspace = height - HEADHEIGHT + LINEY - TABHEIGHT - 2
	count = vspace/TABHEIGHT
	#xpos = (3, 81, 136, 194, 244)
	xpos, tabw = measure_table(('99:99:99', '99999', '99999', '99999', '999-99'))
	title = ("Time", "CID", "LAC", "RNC", "Net")

	draw_setup(ydelta = TABHEIGHT)
	draw_table(xpos, title, space=2)
	if width >= 500:
		count *= 2
	i = 0
	for v in loc_log[-count:]:
		t = time.strftime("%H:%M:%S ", time.localtime(v[0]))
		(mcc, mnc, lac, cid) = v[1]
		if mcc is None:
			cid = u"Offline"
			net = lac = rnc = u""
		else:
			(cid, rnc) = decode_cid(mcc, mnc, cid)
			net = '%03i-%02i' % (mcc, mnc)
		if (i == (count/2)) and (width >= 500):
			xpos = map(lambda x: x+400, xpos)
			draw_setup(ydelta = TABHEIGHT)
			draw_table(xpos, title, space=2)
		draw_table(xpos, (t, cid, lac, rnc, net))
		i += 1

def draw_gps(size):
	global gpsdata, gpsmodule, gpson, img, cell_lat, cell_lon
	(w, h) = size
	draw_setup()
	#xpos = (3, 75)
	xpos, tabw = measure_table(('Accuracy:', 'XXX'))
	if (gpson == 1) and (len(gpsdata) == 15):
		draw_table(xpos, ('Modul:', gpsdata[6]+u' ('+unicode(gpsmodule)+u')'))
		draw_table(xpos, ('Lat:', '%0.6f'%(gpsdata[1])+u''))
		draw_table(xpos, ('Lon:', '%0.6f'%(gpsdata[2])+u''))
		draw_table(xpos, ('Altitude:', ('%0.1f m'%gpsdata[3])))
		draw_table(xpos, ('Accuracy:', ('H: %0.1f m   V: %0.1f m'%(gpsdata[4], gpsdata[5]))))
		draw_table(xpos, ('Speed:', ('%0.1f km/h'%gpsdata[8])))
		draw_table(xpos, ('Heading:', ('%0.1f'%gpsdata[10])+u''))
		if (cell_lat != u'999.99999'):
			(dx, az) = distance(float(gpsdata[1]), float(gpsdata[2]), float(cell_lat), float(cell_lon))
			#(dx, az) = distance(50.07, 6.07, 50.07, 6.07)
			draw_table(xpos, ('Direction:', ('%0.1f'%az+u'')))
			draw_table(xpos, ('Distance:', ('%0.3f km'%dx)))
		draw_table(xpos, ('SAT (Fix):', unicode(gpsdata[13])+u' ('+unicode(gpsdata[14])+u')'))
	elif len(gpsdata) >= 2:
		# Display Error from gpsdata[1]
		draw_text(3, u'No data available:')
		draw_text(3, unicode(gpsdata[1]))
	else:
		draw_setup(h/2)
		draw_text(int(w/2)-30, u'GPS OFF')

def circle(x,y,radius=5, outline=(255,255,255), fill=0xffff00, width=1):
	global img
	img.ellipse((x-radius, y-radius, x+radius, y+radius), outline, fill, width)
		
def draw_radar(size):
	global gpsdata, gpsmodule, gpson, img, cell_lat, cell_lon
	(w, h) = size
	draw_setup()
	zerox = w/2
	zeroy = (h-HDLH)/2+HDLH
	if (h-HDLH) < w:
		maxr = (h-HDLH)/2
	else:
		maxr = w/2
	teiler = maxr/3	
	
	img.line((zerox-10,zeroy,zerox+10,zeroy),grid,width=1)
	img.line((zerox,zeroy-10,zerox,zeroy+10),grid,width=1)
	circle(zerox,zeroy,maxr,outline=grid,fill=None)
	circle(zerox,zeroy,maxr-teiler,outline=grid,fill=None)
	circle(zerox,zeroy,maxr-2*teiler,outline=grid,fill=None)
	#circle(zerox,zeroy,maxr/3,fill=None)
	#circle(zerox,zeroy,maxr/4,fill=None)
	for i in range(0,360,30):
		alf = (90-i)*math.pi/180
		x = math.cos(alf)*maxr
		y = math.sin(alf)*maxr
		img.line((zerox,zeroy,zerox+x,zeroy-y),grid,width=1)
		img.point((zerox+x,zeroy-y),grid,width=8)
	xpos,width = measure_table(['5.999km'], ['A:999'])
	if (gpson == 1) and (len(gpsdata) == 15):
		if (cell_lat != u'999.99999') and (gpsdata[14] > 2):
			(dx, dir) = distance(float(gpsdata[1]), float(gpsdata[2]), float(cell_lat), float(cell_lon))
			head = gpsdata[10]
			angle = diffangle(head,dir)
			if angle > 0:
				alf = (90-angle)*math.pi/180
			draw_table(xpos, ('%0.3fkm'%dx,u'A:'+('%0.0f'%angle)+u''), width=w)
			if dx > 30:
				dxr = maxr/75*dx
				draw_table(xpos, (u'[25km]',u''), width=w)
				radarcolor = (255,255,255)
			elif dx > 9:
				dxr = maxr/30*dx
				draw_table(xpos, (u'[10km]',u''), width=w)
				radarcolor = (0,255,0)
			elif dx > 3:
				dxr = maxr/9*dx
				draw_table(xpos, (u'[3km]',u''), width=w)
				radarcolor = (255,255,0)
			elif dx > 0.9:
				dxr = maxr/3*dx
				draw_table(xpos, (u'[1km]',u''), width=w)
				radarcolor = (255,127,0)
			else:
				dxr = maxr/0.9*dx
				draw_table(xpos, (u'[300m]',u''), width=w)
				radarcolor = (255,0,0)
			x = math.cos(alf)*dxr
			y = math.sin(alf)*dxr
			img.point((zerox+x,zeroy-y),radarcolor,width=15)
			draw_space(h-4.5*HDLH)
			draw_table(xpos, (u'D:'+('%0.0f'%dir)+u'',u'H:'+('%0.0f'%head)+u''), width=w)
	
	
def wlan_scan():
	global wscan, wlanquery_list, wlan_pid
	wlan_pid = os.getpid()
	wlanquery_list = []
	try:
		wscan = wlantools.scan(False)
	except:
		wscan = []
	# for hidden ssid
	for i in range(len(wscan)):
		ssid = wscan[i]['SSID']
		if (ssid.count(chr(0)) == len(ssid)) and (len(ssid) > 0):
			wscan[i]['SSID'] = u'<no ssid> '+unicode(len(ssid))+u' Chrs' 
		else:
			ssid = ssid.replace(chr(0),"")
			ssid = ssid.replace(chr(10),"")
			ssid = ssid.replace(chr(13)," ")
			ssid = ssid.replace(chr(59),",")
			ssid = ssid.replace(chr(34),"``")
			ssid = ssid.replace(chr(27),"`")
			wscan[i]['SSID'] = ssid
	for i in range(len(wscan)):
		wlanquery_list.append(query_wlan(wscan[i]))
		if wlogger:
			if (gpson == 1) and (len(gpsdata) == 15) and str(gpsdata[1]) != 'NaN':
				# Convert lat, lon to formatted strings
				(lon, lat) = map(lambda x: "%2.6f" % x, gpsdata[1:3])
			else:
				lon = lat = 'n/a'
			writewlog((time.strftime("%Y/%m/%d"), time.strftime("%H:%M:%S"), wscan[i]['BSSID'], wscan[i]['SSID'], wscan[i]['RxLevel'], lat, lon))

def bt_mainthread():
	global bt_busy, bt_err
	thread.start_new_thread(bt_scan,())
	time.sleep(1)
	while bt_busy and (bt_scan_time < config['BT_SCAN_TIMEOUT']):
		time.sleep(1)
	if bt_scan_time > (config['BT_SCAN_TIMEOUT']-1):
		bt_err += 1
		#thread.start_new_thread(reader,(u'ein Fehler',))
		blues.off()
		time.sleep(5)
		blues.on()
		time.sleep(5)
		bt_busy = False

def dec2bin(number):
	result = ''
	while number:
		result = str(number % 2) + result
		number /= 2
	return result

		
def bt_device_class(device_class):
	if len(device_class) >= 3:
		device_class = device_class[-3:]
		major_device_class = device_class[:1]
		major_device_class = int(major_device_class,16)
		minor_device_class = device_class[1:]
		minor_device_class = int(minor_device_class,16)
		if major_device_class == 0:
			return u'Miscellaneous'
		elif major_device_class == 1:
			if minor_device_class == 0:
				return u'Computer Class'
			elif minor_device_class == 4:
				return u'Desktop'
			elif minor_device_class == 8:
				return u'Server'
			elif minor_device_class == 12:
				return u'Laptop'
			elif minor_device_class == 16:
				return u'Handheld PC/PDA'
			elif minor_device_class == 20:
				return u'Palm sized PC/PDA'
			elif minor_device_class == 24:
				return u'Wearable Computer'
			else:
				return u'New Computer Class'
		elif major_device_class == 2:
			if minor_device_class == 0:
				return u'Phone Class'
			elif minor_device_class == 4:
				return u'Cellular'
			elif minor_device_class == 8:
				return u'Cordless'
			elif minor_device_class == 12:
				return u'Smartphone'
			elif minor_device_class == 16:
				return u'Wired modem'
			elif minor_device_class == 20:
				return u'Common ISDN Access'
			else:
				return u'New Phone Class'
		elif major_device_class == 3:
			return u'Access point'
		elif major_device_class == 4:
			if minor_device_class == 0:
				return u'Audio/Video'
			elif minor_device_class == 4:
				return u'Wearable Headset'
			elif minor_device_class == 8:
				return u'Hands-free Device'
			elif minor_device_class == 12:
				return u'New Audio/Video'
			elif minor_device_class == 16:
				return u'Microphone'
			elif minor_device_class == 20:
				return u'Loudspeaker'
			elif minor_device_class == 24:
				return u'Headphones'
			elif minor_device_class == 28:
				return u'Portable Audio'
			elif minor_device_class == 32:
				return u'Car audio'
			elif minor_device_class == 36:
				return u'Set-top box'
			elif minor_device_class == 40:
				return u'HiFi Audio Device'
			elif minor_device_class == 44:
				return u'VCR'
			elif minor_device_class == 48:
				return u'Video Camera'
			elif minor_device_class == 52:
				return u'Camcorder'
			elif minor_device_class == 56:
				return u'Video Monitor'
			elif minor_device_class == 60:
				return u'Vid. Disp. & Speaker'
			elif minor_device_class == 64:
				return u'Video Conferencing'
			elif minor_device_class == 68:
				return u'New Audio/Video'
			elif minor_device_class == 72:
				return u'Gaming/Toy'
			else:
				return u'New Audio/Video'
		elif major_device_class == 5:
			bin_minor_class = int(dec2bin(minor_device_class))
			bin_minor_class = '%08i' % bin_minor_class
			bin_minor_1 = bin_minor_class[:2]
			bin_minor_2 = bin_minor_class[2:5]
			if bin_minor_1 == '01':
				dev1 = u'Keyboard'
			elif bin_minor_1 == '10':
				dev1 = u'Pointing Device'
			elif bin_minor_1 == '11':
				dev1 = u'Combo Key/Pointing'
			else:
				dev1 = u''
			if bin_minor_2 == '0001':
				dev2 = u'Joystick'
			elif bin_minor_2 == '0010':
				dev2 = u'Gamepad'
			elif bin_minor_2 == '0011':
				dev2 = u'Remote Control'
			elif bin_minor_2 == '0100':
				dev2 = u'Sensing Device'
			elif bin_minor_2 == '0101':
				dev2 = u'Digitizer tablet'
			elif bin_minor_2 == '0110':
				dev2 = u'Card Reader'
			else:
				dev2 =u''
			if (len(dev1) == 0) and (len(dev2) == 0):
				return u'Peripheral'
			elif (len(dev1) > 0) and (len(dev2) == 0):
				return dev1
			elif (len(dev1) == 0) and (len(dev2) > 0):
				return dev2
			else:
				return dev1 + u'/' + dev2
		elif major_device_class == 6:
			dev1 = dev2 = dev3 = dev4 = u''
			bin_minor_class = int(dec2bin(minor_device_class))
			bin_minor_class = '%08i' % bin_minor_class
			bin_minor_1 = bin_minor_class[:4]
			if bin_minor_1[0] == '1':
				dev1 = u'Printer'
			if bin_minor_1[1] == '1':
				dev2 = u'Scanner'
			if bin_minor_1[2] == '1':
				dev3 = u'Camera'
			if bin_minor_1[3] == '1':
				dev4 = u'Display'
			dev = dev1+dev2+dev3+dev4
			if len(dev) == 0:
				return u'Imaging'
			else:
				return dev
		elif major_device_class == 7:
			if minor_device_class == 0:
				return u'Wearable Class'
			elif minor_device_class == 4:
				return u'Wrist Watch'
			elif minor_device_class == 8:
				return u'Pager'
			elif minor_device_class == 12:
				return u'Jacket'
			elif minor_device_class == 16:
				return u'Helmet'
			elif minor_device_class == 20:
				return u'Glasses'
			else:
				return u'New Wearable Class'
		elif major_device_class == 8:
			if minor_device_class == 0:
				return u'Toy Class'
			elif minor_device_class == 4:
				return u'Robot'
			elif minor_device_class == 8:
				return u'Vehicle'
			elif minor_device_class == 12:
				return u'Doll / Action Figure'
			elif minor_device_class == 16:
				return u'Controller'
			elif minor_device_class == 20:
				return u'Game'
			else:
				return u'New Toy Class'
		elif major_device_class == 9:
			if minor_device_class == 0:
				return u'Medical Class'
			elif minor_device_class == 4:
				return u'Blood Pressure Monitor'
			elif minor_device_class == 8:
				return u'Thermometer'
			elif minor_device_class == 12:
				return u'Weighing Scale'
			elif minor_device_class == 16:
				return u'Glucose Meter'
			elif minor_device_class == 20:
				return u'Pulse Oximeter'
			elif minor_device_class == 24:
				return u'Heart/Pulse Rate Monitor'
			elif minor_device_class == 28:
				return u'Medical Data Display'
			else:
				return u'New Medical Class'
		else:
			return u'unknown'
	else:
		return u'n/a'
		
def bt_scan():
	global btscan, btquery_list, bt_busy, bt_scan_time
	bt_busy = True
	bt_scan_time = 0
	try:
		btscan = lightblue.finddevices()
	except:
		btscan = []
	btquery_list = []
	for i in range(len(btscan)):
		dc = unicode(btscan[i][2])
		if len(dc) > 0:
			dc = unicode("%X"%(int(dc)))
			btscan[i] =[btscan[i][0], btscan[i][1], dc, bt_device_class(dc)]
		else:
			btscan[i] =[btscan[i][0], btscan[i][1], dc, u'']
	for i in range(len(btscan)):
		ssid = btscan[i][1]
		if (ssid.count(chr(0)) == len(ssid)) and (len(ssid) > 0):
			btscan[i] =[btscan[i][0], u'<no ssid> '+unicode(len(ssid))+u' Chrs', btscan[i][2], btscan[i][3]]
		else:
			ssid = ssid.replace(chr(0),"")
			ssid = ssid.replace(chr(10),"")
			ssid = ssid.replace(chr(13)," ")
			ssid = ssid.replace(chr(59),",")
			ssid = ssid.replace(chr(34),"``")
			ssid = ssid.replace(chr(27),"`")
			btscan[i] = [btscan[i][0], ssid, btscan[i][2], btscan[i][3]]
		
	for i in range(len(btscan)):
		btquery_list.append(query_bt(btscan[i]))
	bt_busy = False
	
def draw_wlan(size):
	global wlan, wscan, wlanlist
	(w, h) = size
	draw_setup()
	if not wlan:
		draw_text(3, u'wlantools are missing!')
		return
	if len(wscan) == 0:
		draw_text(3, u'no WLANs found.')
		draw_text(3, unicode(len(wlan_list)-1)+u' WLANs in Database.')
		draw_text(3, unicode(newwlans)+u' new WLANs found.')
		draw_text(3, unicode(wlangpsupdate)+u' WLAN GPS Updates done.')
		return

	if w < 250:
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['#', 'CH', '-99'])
		#xpos = (TABSPACE/2, w-TLENGTH_C-TLENGTH_RXL-2*TABSPACE, w-TLENGTH_RXL-TABSPACE/2)
		if show_ssid:
			draw_table(xpos, (u'SSID   '+unicode(len(wlan_list)-1)+u'('+unicode(newwlans)+u'-'+unicode(wlangpsupdate)+u')', u'C', u'CH', u'RXL'), width=w)
		else:
			draw_table(xpos, (u'BSSID  '+unicode(len(wlan_list)-1)+u'('+unicode(newwlans)+u'-'+unicode(wlangpsupdate)+u')', u'C', u'CH', u'RXL'), width=w)
	elif w < 500:
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['WpaPsk', 'CH', '-99'])
		if show_ssid:
			draw_table(xpos, (u'SSID       '+unicode(len(wlan_list)-1)+u'('+unicode(newwlans)+u'-'+unicode(wlangpsupdate)+u')', u'Crypt', u'CH', u'RXL'), width=w)
		else:
			draw_table(xpos, (u'BSSID       '+unicode(len(wlan_list)-1)+u'('+unicode(newwlans)+u'-'+unicode(wlangpsupdate)+u')', u'Crypt', u'CH', u'RXL'), width=w)		
	else:
		#xpos = (3, 350, 500, w-TLENGTH_199DBM-3)
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['99:99:99:99:99:99l', 'Infrastructurel', 'WpaPskW', 'CHl', '-99dBm'])
		draw_table(xpos, (u'SSID       '+unicode(len(wlan_list)-1)+u'('+unicode(newwlans)+u'-'+unicode(wlangpsupdate)+u')', u'BSSID', u'ConnectMode', u'Crypt', u'CH', u'RxLev'), width=w)
	draw_space(2)
	for i in range(len(wscan)):
		if wscan[i]['SecurityMode']==u'Open':
			crypt = u''
		elif wscan[i]['SecurityMode']==u'Wep':
			crypt = u'+'
		else:
			crypt = u'#'
		rxl = -abs(wscan[i]['RxLevel'])
		if len(wscan) == len(wlanquery_list): #to avoid list index out of range errors
			if rxl <= -100:
				rxl = -rxl
			if w < 250:
				if show_ssid:
					if wscan[i]['ConnectionMode'] == 'Adhoc':
						draw_table(xpos, (wscan[i]['SSID'], crypt, wscan[i]['Channel'], rxl), width=w, highlight=wlanquery_list[i], italic=True)
					else:
						draw_table(xpos, (wscan[i]['SSID'], crypt, wscan[i]['Channel'], rxl), width=w, highlight=wlanquery_list[i])
				else:
					if wscan[i]['ConnectionMode'] == 'Adhoc':
						draw_table(xpos, (wscan[i]['BSSID'], crypt, wscan[i]['Channel'], rxl), width=w, highlight=wlanquery_list[i], italic=True)
					else:
						draw_table(xpos, (wscan[i]['BSSID'], crypt, wscan[i]['Channel'], rxl), width=w, highlight=wlanquery_list[i])
			elif w < 500:
				if show_ssid:
					if wscan[i]['ConnectionMode'] == 'Adhoc':
						draw_table(xpos, (wscan[i]['SSID'], \
							wscan[i]['SecurityMode'], \
							wscan[i]['Channel'], \
							unicode(rxl)), width=w, highlight=wlanquery_list[i], italic=True)
					else:
						draw_table(xpos, (wscan[i]['SSID'], \
							wscan[i]['SecurityMode'], \
							wscan[i]['Channel'], \
							unicode(rxl)), width=w, highlight=wlanquery_list[i])
				else:
					if wscan[i]['ConnectionMode'] == 'Adhoc':
						draw_table(xpos, (wscan[i]['BSSID'], \
							wscan[i]['SecurityMode'], \
							wscan[i]['Channel'], \
							unicode(rxl)), width=w, highlight=wlanquery_list[i], italic=True)
					else:
						draw_table(xpos, (wscan[i]['BSSID'], \
							wscan[i]['SecurityMode'], \
							wscan[i]['Channel'], \
							unicode(rxl)), width=w, highlight=wlanquery_list[i])					
			else:
				draw_table(xpos, (wscan[i]['SSID'], \
					wscan[i]['BSSID'], \
					wscan[i]['ConnectionMode'], \
					wscan[i]['SecurityMode'], \
					wscan[i]['Channel'], \
					unicode(rxl)+u'dBm'), width=w, highlight=wlanquery_list[i])

def draw_clf(size):
	#global cell_lon, cell_lat
	(w, h) = size
	draw_setup()
	draw_text(CENTER, unicode(len(clf)-1)+u' cells', space=2, width=w)
	draw_space(20)
	draw_text(CENTER, cell_description, space=2, width=w)
	draw_space(10)
	#dcell_lat = '%0.6f'%float(cell_lat)
	#dcell_lon = '%0.6f'%float(cell_lon)
	draw_text(CENTER, u'LAT: '+ cell_lat, space=2, width=w)
	draw_text(CENTER, u'LON: '+ cell_lon, space=2, width=w)
	draw_space(10)
	draw_text(CENTER, u'BT Save Error: '+unicode(bt_save_error), space=2, width=w)
	draw_text(3, unicode(invalid_bt), space=2, width=w)
	
def draw_bt(size):
	global btscan, btlist
	(w, h) = size
	draw_setup()
	if not bt:
		draw_text(3, u'LightBlue or BlueS are missing!')
		return
	if len(btscan) == 0:
		draw_text(3, u'no BT Devices found.')
		draw_text(3, unicode(len(bt_list)-1)+u' BTs in Database.')
		draw_text(3, unicode(newbt)+u' new BTs found.')
		draw_text(3, unicode(btgpsupdate)+u' BT Updates done.')
		return
	if w < 250:
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['WWWWW'])
		#xpos = (TABSPACE/2, w-TLENGTH_C-TLENGTH_RXL-2*TABSPACE, w-TLENGTH_RXL-TABSPACE/2)
		if show_ssid:
			draw_table(xpos, (u'Name   '+unicode(len(bt_list)-1)+u'('+unicode(newbt)+u'-'+unicode(btgpsupdate)+u')', u'Class'), width=w)
		else:
			draw_table(xpos, (u'MAC  '+unicode(len(bt_list)-1)+u'('+unicode(newbt)+u'-'+unicode(btgpsupdate)+u')', u'Class ID'), width=w)
	elif w < 500:
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['WWWWWWWW'])
		if show_ssid:
			draw_table(xpos, (u'Name       '+unicode(len(bt_list)-1)+u'('+unicode(newbt)+u'-'+unicode(btgpsupdate)+u')', u'Class'), width=w)
		else:
			draw_table(xpos, (u'MAC       '+unicode(len(bt_list)-1)+u'('+unicode(newbt)+u'-'+unicode(btgpsupdate)+u')', u'Class ID'), width=w)		
	else:
		#xpos = (3, 350, 500, w-TLENGTH_199DBM-3)
		xpos,width = measure_table(['WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW'], ['99:99:99:99:99:99l', '2000000', 'Video Display & LoudSpeaker'])
		draw_table(xpos, (u'Name       '+unicode(len(bt_list)-1)+u'('+unicode(newbt)+u'-'+unicode(btgpsupdate)+u')', u'MAC', u'Class ID', u'Class'), width=w)
	draw_space(2)
	for i in range(len(btscan)):
		if len(btscan) == len(btquery_list): #to avoid list index out of range errors
			if w < 250:
				if show_ssid:
					draw_table(xpos, (btscan[i][1], btscan[i][3]), width=w, highlight=btquery_list[i])
				else:
					draw_table(xpos, (btscan[i][0], btscan[i][2]), width=w, highlight=btquery_list[i])
			elif w < 500:
				if show_ssid:
					draw_table(xpos, (btscan[i][1], btscan[i][3]), width=w, highlight=btquery_list[i])
				else:
					draw_table(xpos, (btscan[i][0], btscan[i][2]), width=w, highlight=btquery_list[i])							
			else:
				draw_table(xpos, (btscan[i][1], btscan[i][0], btscan[i][2], btscan[i][3]), width=w, highlight=btquery_list[i])	


def reader(text):
	try:
		audio.say(text)
	except Exception, error:
		# no GUI from sub-thread!
		#appuifw.note(u"Sound Error: "+unicode(error),'error')
		pass

def gps_update(args):
	global gpsdata, gpson
	gpsdata = args
	if (not gpson):
		lockgps.signal()
		gpsdata = [0, 'GPS stopped']

def gps_find_device(lr, type):
	count = lr.GetNumModules()
	for i in range(count):
		info = lr.GetModuleInfoByIndex(i)
		if ((info[3] == type) and ((info[2] & locationrequestor.ETechnologyNetwork) == 0)):
			return info[0]
	return -1

def gps_worker():
	global lockgps, gpsmodule
	lockgps = e32.Ao_lock()
	# create LocationRequestor instance
	lr = locationrequestor.LocationRequestor()
	# show default module
	#print 'Default', lr.GetDefaultModuleId()
	# show number of modules
	#print 'Count', count
	# find internal GPS (if any)
	if config['GPS'] == Setup.GPS_INTERNAL:
		probe = [locationrequestor.EDeviceInternal,
		         locationrequestor.EDeviceExternal]
	else:
		probe = [locationrequestor.EDeviceExternal,
		         locationrequestor.EDeviceInternal]
	
	id = gps_find_device(lr, probe[0])
	if id == -1:
		id = gps_find_device(lr, probe[1])

	if id == -1:
		gpsdata = [0, 'Neither internal nor external GPS available']
		return
	gpsmodule = unicode(id)

	# set update options
	lr.SetUpdateOptions(1, 25, 0, 1)
	# connect to position module
	lr.Open(id)
	# install callback
	try:
		lr.InstallPositionCallback(gps_update)
	except Exception, reason:
		#appuifw.note(unicode(reason),'error')
		pass

	lockgps.wait()
	lr.Close()

def log_worker():
	global gsmloc, gsmloc_real, rxl, gui, t_last, running, script_lock
	t_old = 0
	while running:
		t_last = time.time()
		try:
			rxl = -sysinfo.signal_dbm()
			if rxl == 0:
				# Workaround Nokia dumbness:
				rxl = None
		except SystemError:
			rxl = None
		try:
			oldloc = gsmloc
			gsmloc_real = location.gsm_location()
			#if t_last % 10 < 3:
			#	gsmloc_real = None
			# Workaround for "no location during data traffic"
			if gsmloc_real is None and rxl: # and t_old + offlinetimeout < t_last:
				# We are busy, simulate last cell for history
				gsmloc = oldloc
			else:
				# Update state
				gsmloc = gsmloc_real
				t_old = t_last
		except (ValueError, SystemError):
			gsmloc = gsmloc_real = None
		log_rxl(t_last, rxl)
		if gsmloc is None or not rxl:
			log_loc(t_last, (None, None, None, None))
		else:
			log_loc(t_last, gsmloc)
		gui.signal()
		e32.ao_sleep(1)
	# we are finished
	script_lock.signal()

def read_cell(rxl, umts, mcc, mnc, cid, lac, readlac):
	#sound.set_volume(config['Volume'])
	voice = u''
	if not rxl:
		voice = Voice.offline
	elif config['Voice']==Setup.VOICE_CELL:
		voice = unicode(cid)
	elif config['Voice']==Setup.VOICE_BAND:
		voice = Voice.band[umts] + u"  " + unicode(cid)
	elif config['Voice']==Setup.VOICE_BAND_LAC:
		voice = Voice.band[umts] + u"  " + unicode(cid)
		if readlac:
			voice += u'. L A C '+unicode(lac)
	elif config['Voice']==Setup.VOICE_BAND_LAC_NET:
		voice = Voice.band[umts] + u"  "
		if readlac:
			if mcc in Voice.provider and mnc in Voice.provider[mcc]:
				voice += Voice.provider[mcc][mnc]
			else:
				voice += u'M C C '+unicode(mcc)+u' M N C '+unicode(mnc)
			voice += u". " + unicode(cid) + u'. L A C '+unicode(lac)
		else:
			voice += unicode(cid)
	thread.start_new_thread(reader,(voice,))

def netmonitor():
	global running, toggle, rxl, gsmloc, img, img_dbl, wlan, wlani, wscan, dbsearch, neighbour_updated, lb, gl_size, bt_scan_time
	busytext = ['n/a', 'busy']
	imei=sysinfo.imei()
	ver = sysinfo.os_version()
	oldcid = 0
	oldlac = 0
	t_log = 0
	wlan_autosave = 0
	bt_autosave = 0
	bti = 20
	bt_block = 0
	while running:
		# Block when Camera is active
		while finder:
			e32.ao_sleep(0.5)
		size,offset = appuifw.app.layout(appuifw.EMainPane)
		gl_size = size
		img.rectangle((0,0)+size,outline=border,fill=bg)
		if gsmloc_real is None and gsmloc is not None:
			busy = True
		else:
			busy = False
		if gsmloc is None or not rxl or busy:
			mcc = mnc = lac = lachex = cid = cidhex = longcid = longcidhex = rnc = cid = busytext[busy]
		else:
			(mcc, mnc, lac, cid) = gsmloc
			if cid > 65535:
				umts = 1
				longcid = cid
				longcidhex = "%Xh"%(longcid)
			else:
				umts = 0
				longcid = longcidhex = busytext[busy]
			(cid, rnc) = decode_cid(mcc, mnc, cid)
			try:
				lachex = "%Xh"%(lac)
			except:
				lachex = busytext[busy]
			try:
				cidhex = "%Xh"%(cid)
			except:
				cidhex = busytext[busy]
			if cid != oldcid:
				oldcid = cid
				thread.start_new_thread(query_clf,(mcc, mnc, cid, lac, rnc, umts))
				#query_clf(mcc, mnc, cid, lac, rnc, umts)
				# Cell changed, notify the user
				if config['Light']==Setup.LIGHT_CELL:
					e32.reset_inactivity()
				if config['CellNotify']==Setup.SOUND_SOUND:
					sound_play()
					#thread.start_new_thread(sound_play,())
				elif config['CellNotify']==Setup.SOUND_VOICE:
					read_cell(rxl, umts, mcc, mnc, cid, lac, oldlac != lac)
				oldlac = lac
		if neighbour_updated:
			lb = appuifw.Listbox(neighbour_list, handle_selection)
			neighbour_updated = False
			appuifw.note(u'Neighbour List updated! '+unicode(len(neighbour_list))+u' Neighbour cells found within '+unicode(config['Neighbour Radius'])+u' km Radius', 'info')
		if tab==0:
			appuifw.app.body=canvas
			draw_netmon(lac, mcc, mnc, rnc, rxl, ver, imei, longcid, cidhex, lachex, longcidhex, size, cid)
		elif tab==1:
			appuifw.app.body=canvas
			draw_rxlgraph(size)
		elif tab==2:
			appuifw.app.body=canvas
			draw_history(size)
		elif tab==3:
			appuifw.app.body=canvas
			draw_gps(size)
		elif tab==4:
			appuifw.app.body=canvas
			draw_wlan(size)
		elif tab==5:
			appuifw.app.body=canvas
			draw_clf(size)
		elif tab==6:
			appuifw.app.body=canvas
			draw_radar(size)
		elif tab==7:
			appuifw.app.body=canvas
		elif tab==8:	
			appuifw.app.body=canvas
			draw_bt(size)
		elif tab==9:	
			appuifw.app.body=lb
		elif tab==10:
			appuifw.app.body=canvas
			draw_about(imei)
		# Headline for all but "About"
		if tab <= 8:
			headline(size, cid)

		tmp = img_dbl
		img_dbl = img
		img = tmp
		handle_redraw(())
		if logger:
			if t_log != t_last:
				# Only log coords when GPS is there and values are not NaN
				if (gpson == 1) and (len(gpsdata) == 15) and str(gpsdata[1]) != 'NaN':
					# Convert lat, lon to formatted strings
					(lon, lat) = map(lambda x: "%2.6f" % x, gpsdata[1:3])
				else:
					lon = lat = 'n/a'
				if rxl:
					trxl = rxl
				else:
					trxl = 'n/a'
				writelog((time.strftime("%Y/%m/%d"), time.strftime("%H:%M:%S"), cid, longcid, lac, mcc, mnc, rnc, trxl, lon, lat))
				t_log = t_last
		if config['Light']==Setup.LIGHT_ALWAYS:
			e32.reset_inactivity()
		if wlan and (wlani>=config['Refresh']) and (config['Refresh']>9):
			wlani = 0
			thread.start_new_thread(wlan_scan,())
		if config['Refresh']>9:
			wlani += 1
			wlan_autosave += 1
			if wlan_autosave > config['WLANInter']*60:
				wlan_autosave = 0
				thread.start_new_thread(save_wlan,())
		if config['BT_SCAN'] > 0 and not bt_busy and bt:
			bti += 1
			bt_autosave += 1
			if (bti > config['BT_SCAN']*1) and not bt_busy:
				bti = 0
				thread.start_new_thread(bt_mainthread,())
			if bt_autosave > config['BT_Autosave']*60:
				bt_autosave = 0
				thread.start_new_thread(save_bt,())
		if bt_busy:
			bt_scan_time += 1
		gui.wait()


def handle_redraw(rect):
	global img_dbl, canvas
	
	if mapimg and (tab==7):
		canvas.blit(mapimg, target=(0, 0), source=(map_x, map_y))
	else:
		canvas.blit(img_dbl)
	if status and (tab==7):
		canvas.text((10, 50), status, fill=(0, 0, 255), font="title")

def handle_event(event):
	global img_dbl, canvas, key_repeat, show_ssid
	if event['type'] == appuifw.EEventKeyDown:
		sc = event['scancode']
		key_repeat = 0
		#print event
		if (sc > EScancode0) and (sc <= EScancode0 + tab_max):
			newtab = sc - EScancode0 - 1
			appuifw.app.activate_tab(newtab)
			set_tab(newtab)
		if sc == EScancodeUpArrow:
			if show_ssid:
				show_ssid = False
			else:
				show_ssid = True
	elif event['type'] == appuifw.EEventKey:
		sc = event['scancode']
		key_repeat += 1
		if key_repeat == 2:
			if sc == EScancodeStar:
				toggle_log()
				gui.signal()
			elif sc == EScancodeHash:
				toggle_gps()
				gui.signal()


def standalone():
	# XXX: use appuifw.app.uid()
	# TITLE in full_name() means standalone
	return appuifw.app.full_name().find(TITLE) != -1

def exit_key_handler():
	if appuifw.query(u'Do you really want to exit?', 'query'):
		finish()

def finish():
	global running, s, clf_umts, clf_gsm, neighbour_list, wlan_list
	# inform the worker threads
	running = False
	save_wlan()
	save_bt()
	clf = []
	neighbour_list = []
	wlan_list = []
	bt_list = []
	# let the GUI exit gracefully
	gui.signal()
	if s != None:
		s.close()
	appuifw.app.set_tabs([], None)
	if standalone():
		appuifw.app.set_exit()
		

def main():
	global script_lock, gui, s, SetupForm, canvas, lb, starttime
	canvas = appuifw.Canvas(event_callback=handle_event, redraw_callback=handle_redraw)
	lb = appuifw.Listbox([u'Empty Neighbour List'], handle_selection)
	#appuifw.app.screen='large'
	#appuifw.app.screen='normal'
	appuifw.app.title = TITLE
	appuifw.app.body=canvas
	try:
		envy.set_app_system(1) # try to set system your application
	except: 
		print 'exception !'
		appuifw.note(u"Envy Error!",'error')
	#head = int(round(999.123456789789654565651651351356546646464646841235163526526365265265236526365265235265206352060652050350202656840840684608468468464646))
	script_lock = e32.Ao_lock()
	gui = e32.Ao_lock()
	thread.start_new_thread(log_worker,())
	SetupForm = Setup( )
	SetupForm.loadConfig(silent=True)
	menus_setup()
	load_wlan()
	load_bt()
	appuifw.app.exit_key_handler = exit_key_handler
	#appuifw.app.body.bind(EKeyNo, exit_key_handler)
	#if locreq and config['GPS']:
	#	toggle_gps()
	if standalone():
		#path = os.getcwd()
		path = "E:\\Data\\Others\\PyNetMony\\"
	else:
		path = "E:\\Data\\Others\\PyNetMony\\"
	try:
		#file = os.path.join(path, u'fanfare3.mp3')
		file = path + "fanfare3.mp3"
		s = audio.Sound.open(file)
	except Exception, error:
		appuifw.note(u"Sound Error: s"+unicode(error),'error')
	if bt and (config['BT_SCAN'] > 0):
		if blues.getstate() == 0:
			blues.on()
	starttime = time.time()
	netmonitor()
	script_lock.wait()

if standalone():
	# Standalone: Display exception as note
	try:
		main()
	except Exception, error:
		appuifw.note(u"Fatal Error: "+unicode(error),'error')
else:
	# Python Script Shell: log exception to stdout
	main()
